#ifndef _APPLICATIONFRAME_H
#define _APPLICATIONFRAME_H

#include <qapplication.h>

class ApplicationStorage;
class MainFrame;
class SettingsBox;
class AutosaveBox;

class ApplicationFrame
{
public:
   ApplicationFrame(QApplication *pc_Application);
   ~ApplicationFrame();

   ApplicationStorage *m_pc_ApplicationStorage;

   void AddMainFrame(MainFrame *pc_NewFrame);
   void RemoveMainFrame(MainFrame *pc_OldFrame);

   void ExitCall(MainFrame *pc_CallingFrame);
   void Terminate();

   void LoadBaseData();
   void LoadTranslator();

   void OpenSettingsBox();

   void CalculateTempDirectory();
   
   SettingsBox * m_pc_SettingsBox;
   AutosaveBox * m_pc_AutosaveBox;

private:
   int m_i_NumberOfImages;
   QPtrList<MainFrame> m_Images;


} ;


#endif // _APPLICATIONFRAME_H


