//---------------------------------------------------------------------------
// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the GPL license.
// If you expand this file, please contact me, that I can integrate the
// enhancements in the original file.
//---------------------------------------------------------------------------
// Module: ApplicationStorage
//---------------------------------------------------------------------------
// Purpose: store application wide data.
//---------------------------------------------------------------------------


#include "IconLibrary.h"
#include "QtUtilities.h"
#include "ApplicationStorage.h"
#include <qtranslator.h>

//===========================================================================
//
//===========================================================================

ApplicationStorage::ApplicationStorage()
{
   m_pc_IconLibrary      = NULL;

   m_pc_QtUtility        = NULL;

   m_pc_QApplication     = NULL;
   
   m_pc_QTranslator      = NULL;

   m_pc_ApplicationFrame = NULL;

   m_pc_BaseData         = NULL;
   
   // initital no directory 
   m_qs_LoadDirectory    = "";
   m_qs_TempDirectory    = "";

   m_i_ButtonRegular     = 1; // Button bitmask ( left)
   m_i_ButtonContext     = 2; // right
   m_i_ButtonExtra       = 4; // middle or scrollwheel
   
} // ApplicationStorage() - constructor

//===========================================================================
//
//===========================================================================

QString ApplicationStorage::GetTempDir()
{
   QString qs_Return;
   QString qs_Right;
   int     i_Length;

   qs_Return =  m_qs_TempDirectory;


   // remove / at the end of the path
   i_Length = qs_Return.length();
   while(i_Length >0)
   {
      qs_Right = qs_Return.right(1);
      if(qs_Right.compare("/") != 0)
      {
         break;
      }
      
      qs_Return = qs_Return.left(i_Length-1);
      i_Length -- ;
   }

   return qs_Return;
} // GetTempDir()

//===========================================================================
//
//===========================================================================


