//---------------------------------------------------------------------------
// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the GPL license.
// If you expand this file, please contact me, that I can integrate the
// enhancements in the original file.
//---------------------------------------------------------------------------
// Module: AutosaveBox.c
//---------------------------------------------------------------------------
// Purpose:
//---------------------------------------------------------------------------

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

#include <qlayout.h>
#include <qgrid.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qvgroupbox.h>
#include <qhgroupbox.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qfiledialog.h>

#include "AutosaveBox.h"
#include "ApplicationStorage.h"
#include "BaseData.h"
#include "BaseDataStrings.h"
#include "PixelBuffer.h"
#include "FileLoader.h"
#include "QtUtilities.h"
#include "MainFrame.h"
#include "IconLibrary.h"



//===========================================================================
//
//===========================================================================

AutosaveBox::AutosaveBox(QWidget *parent ):
                        StandardDialog(parent,NULL)
{
   QBoxLayout   *l_Layout;
   QString       qs_Directory;
   QString       qs_LastChar;

   setCaption(tr("Autosave"));

   l_Layout     = new  QVBoxLayout( m_w_TopWidget,1);

   m_pc_FileIconBox  = new QUFileIconWidget(m_w_TopWidget,
                                 QUFileIconWidget::ModeDeleteAll);
   l_Layout->addWidget(m_pc_FileIconBox);   
   
   connect( m_pc_FileIconBox,
               SIGNAL(IconSelected(QString )),
               SLOT(IconSelected(QString )) );

   qs_Directory = g_Application->m_qs_TempDirectory;

   // add a slash at the end
   qs_LastChar = qs_Directory.right(1);
   if(qs_LastChar.compare("/") != 0)
   {
      qs_Directory+= "/" ;
   }

   qs_Directory +="Autosave";

   m_pc_FileIconBox->SetPath(qs_Directory);
   m_pc_FileIconBox->SetWildcard("*");

   m_pc_FileIconBox->ActicateSelection();                       
} // AutosaveBox()

//===========================================================================
//
//===========================================================================

AutosaveBox::~AutosaveBox( )
{
} // ~AutosaveBox()

//===========================================================================
//
//===========================================================================

void AutosaveBox::IconSelected(QString qs_Filename)
{
   MainFrame::NewPicture(qs_Filename);

} // IconSelected()

//===========================================================================
//
//===========================================================================


int AutosaveBox::GetNumberOfFiles()
{
   return m_pc_FileIconBox->GetNumberOfFiles();
} // GetNumberOfFiles()

//===========================================================================
//
//===========================================================================


