#ifndef _BSPLINE_H
#define _BSPLINE_H


#include "D3Utilities.h"

class BSpline
{
public:

   BSpline();
   ~BSpline();
   

   int CalculateBSpline2Dimensions(
            D3Matrix *p_c_DeBoorPoints,   
            int  i_PointCountRow,       
            int  i_PointCountColumn,      
            D3Matrix *pc_ResultPoints,   
            int  &i_RealPointCountRow,     
            int  &i_RealPointCountColumn     
          );            
   void SetOrder(int i_OrderOfBSpline);
private:

   int ColumnCurve (
           double d_ParameterValue,       
           int  i_NodeIntervalRow,
           D3Vector *pc_RowVector,
           int  &i_RealPointCount, 
           D3Vector *pc_Help,
           D3Vector *pc_CyclicHelpVektor, 
           D3Vector *pc_DeBoorHelp
        );

   int CalculateBSpline1Dimension(
            D3Vector *pc_GivenDeBoorPoints,
            int  i_NumberOfPoints,
            D3Vector *pc_CalculatedCurvePoints,
            int  &i_RealPointCount
           ) ;

   void DeBoorPoints(
                   D3Vector     *pc_GivenDeBoorPoints,
                   int          i_NumberOfPoints,
                   double       d_ParameterValue,
                   int          i_KnotIndex,
                   D3Vector     *pc_DeBoorHelp,
                   D3Coordinate &c_WishedCurvePoint
                  );
   int TruncateIndex(int i_Index,
                     int i_OrderOfBSpline,
                     int i_NumberOfPoints);

   int Minimum(int i,int j);

   int m_i_OrderOfBSpline;
   
   D3Matrix *m_pc_DeBoorPoints ;
   int      m_i_NumberPointsRow;
   int      m_i_NumberPointsColumn;
   
//   int Min(int i,int j);


};



#endif // _BSPLINE_H
