#ifndef _BASEDATA_H
#define _BASEDATA_H

#include <qstringlist.h>

class BaseData
{
public:
   BaseData();
   BaseData(QString qs_Filename);
   ~BaseData();

   bool LoadFile(QString qs_Filename);

   bool SaveFile();
      
   bool GetValue(QString qs_Identifier,
                  QString &qs_StoredValue);

   bool GetValue(QString qs_Identifier,
                  int &i_StoredValue);

   bool GetValue(QString qs_Identifier,
                  double &d_StoredValue);

   bool GetValue(QString qs_Identifier,
                  bool &b_StoredValue);

   bool SetValue(QString qs_Identifier,
                  QString qs_Value);

   bool SetValue(QString qs_Identifier,
                  int i_Value);

   bool SetValue(QString qs_Identifier,
                  double d_Value);

   bool SetValue(QString qs_Identifier,
                  bool b_Value);

   static QString CalculateFilename(
         QString qs_ApplicationName);                
private:

   int LocateLine(QString qs_Identifier,
               QString &qs_StoredValue);
   
   QStringList m_List;
   QString     m_qs_Filename;
   bool        m_b_Loaded;
   bool        m_b_Modified;
} ; // BaseData

#endif // _BASEDATA_H
