#ifndef _COLORCALCULATION_H
#define _COLORCALCULATION_H

#include "PTypes.h"

class ColorCalculation
{
public:
   static void RGBToHLS(int i_R  , int i_G  , int i_B,
                        int &i_H , int &i_L , int &i_S);
   static void PixelToHLS(Pixel p_Pixel,
                        int &i_H , int &i_L , int &i_S);


   static void HLSToRGB(int i_H  , int i_L  , int i_S,
                        int &i_R , int &i_G , int &i_B);
   static Pixel HLSToPixel(int i_H  , int i_L  , int i_S);

   static Pixel TransparentColor(Pixel p_Old,
                                 Pixel p_New,
                                 int i_TransparencyFactor);

   static Pixel MixColor(Pixel p_From,
                         Pixel p_To,
                         float i_MixFactor);
   
   static Pixel TransparentAirBrushColor(Pixel p_Old,
                                 Pixel p_New,
                                 int i_TransparencyFactor);
   static int ColorDifferenceRGB(Pixel p_Color1,Pixel p_Color2);

} ;

#endif // _COLORCALCULATION_H


