#ifndef _CUBICSPLINE_H
#define _CUBICSPLINE_H


#include "Geometry.h"

class CubicBezierSpline
{
public:
   CubicBezierSpline();
   ~CubicBezierSpline();

   void StartCalculationSplinePoints(GeoCoordinate Points[4],
                           bool b_Append=false);
   void CalculateSubPoints(float f_TLeft,
               GeoCoordinate c_Left,
               float f_TRight,
               GeoCoordinate c_Right
               );

   GeoCoordinateList *GetResultList();

   static GeoCoordinateList *CalculateInterpolationList(
         GeoCoordinateList *pc_Original,
         float f_OffsetX=0.0,
         float f_OffsetY=0.0,
         bool  b_OpenCurve=false
         );
   void SetSplineStyle(bool b_Open);
               
private:
   GeoCoordinate CalculatePointAt(float t);        
   
   GeoCoordinate m_c_InterpolationPoints[4];

   GeoCoordinateList m_l_SubPoints;

   bool m_b_OpenCurve;
};



#endif // _CUBICSPLINE_H
