
#ifndef _D3UTILITIES_H
#define _D3UTILITIES_H


class D3Coordinate
{
public:
   double x;
   double y;
   double z1;
   double z2;
   double z3;

   D3Coordinate();
//   D3Coordinate(int i_X,int i_Y, int i_Z);
   D3Coordinate(int i_X,int i_Y, int i_Z1,int i_Z2,int i_Z3);
   
   D3Coordinate& operator+( D3Coordinate  other);

   D3Coordinate& operator-( D3Coordinate  other);

   D3Coordinate operator* (  double  d_Value) ;

};

class D3Vector
{
public:
   D3Vector(int i_Dimension);
   ~ D3Vector();
   D3Coordinate Get(int i_Index);
   void Set(int i_Index, D3Coordinate d_Value);
   D3Coordinate *m_pc_Coordinates;
   int m_i_Dimension;
   

}; // D3Vector
   
class D3Matrix
{
public:
   D3Matrix(int i_DimensionX, int i_DimensionY);
   ~ D3Matrix();
   D3Coordinate Get(int i_IndexX,int i_IndexY);
   void Set(int i_IndexX,int i_IndexY, D3Coordinate d_Value);

   int GetWidth();
   int GetHeight();
   
   D3Coordinate *m_pc_Coordinates;
private:
   int m_i_DimensionX;
   int m_i_DimensionY;


}; // D3Maxtrix

#endif // _D3UTILITIES_H

