#ifndef _DRAGANDDROP_H
#define _DRAGANDDROP_H

#include <qevent.h>
#include "DragAndDropConstants.h"
#include "PTypes.h"

class PixelBuffer;

class DragAndDrop
{
public:
   enum
   {
      AcceptPlain       = 1,
      AcceptPixelbuffer = 2,
      AcceptColor       = 4

   };
   DragAndDrop();
   ~DragAndDrop();

   bool IsEventAcceptable(QDragEnterEvent* event);

   int GetEventType(QDropEvent* event);

   void SetAcceptType(int i_AcceptType);

   PixelBuffer *GetPixelBuffer(QDropEvent* event);
   Pixel       GetColor(QDropEvent* event);
   QString     GetFilename(QDropEvent* event);

private:
   // a bitmask with all type
   int m_i_AcceptType;

   QString GetDragSourceName(QByteArray *qba_Data,
                                QString *pqs_Value= NULL);
   
   QString GetDragSourceText(QByteArray *qba_Data);

};

#endif // _DRAGANDDROP_H

