#ifndef _GRAPHIC_OBJECT_ATTRIBUTE_H
#define _GRAPHIC_OBJECT_ATTRIBUTE_H

#include <qstring.h>

#include "PTypes.h"
#include "Geometry.h"
#include "PixelBuffer.h"



//#########################################################################

class GraphicObjectAttribute
{
public:
   GraphicObjectAttribute();
   GraphicObjectAttribute(PericoFileWriter *pc_FileWriter);
   virtual ~GraphicObjectAttribute();

   // different type of object attributes
   enum
   {
       Invalid=0,
       Color=1,
       StartPoint,
       EndPoint,
       Image,
       RotationAngle,
       AllowsLineEndMovement,
       PointList,
       ClosedFigure
   };
   int  m_e_ObjectAttributeType;


   Pixel         m_p_Color;
   GeoCoordinate m_c_Coordinate;
   double        m_d_Value;
   PixelBuffer  *m_pc_ImageData;
   int           m_i_Value;
   GeoCoordinateList m_l_Coordinates;

   virtual int WriteFile(PericoFileWriter *pc_FileWriter,QString qs_Name);
   virtual int LoadFile(PericoFileWriter *pc_FileWriter);

   // some convinience functions
   static GraphicObjectAttribute *GraphicAttributeStartpoint( GeoCoordinate c_Coordinate);
   static GraphicObjectAttribute *GraphicAttributeEndpoint(GeoCoordinate c_Coordinate);
   static GraphicObjectAttribute *GraphicAttributeColor( Pixel p_Color);
   static GraphicObjectAttribute *GraphicAttributeRotationAngel( double d_Angle);
   static GraphicObjectAttribute *GraphicAttributeImage( PixelBuffer *pc_Image);

   Pixel GetColor();
   void  SetColor(Pixel p_Color );
   double GetRotationAngle();
   void   SetRotationAngle(double d_Angle);
   GeoCoordinate GetStartPoint();
   GeoCoordinate GetEndPoint();

   GeoCoordinateList *GetCoordinateList();
private:
   int WritePointList(PericoFileWriter *pc_FileWriter);
   int LoadPointList(PericoFileWriter *pc_FileWriter);

};

//#########################################################################


#endif // _GRAPHIC_OBJECT_ATTRIBUTE_H

