//---------------------------------------------------------------------------
// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the GPL license.
// If you expand this file, please contact me, that I can integrate the
// enhancements in the original file.
//---------------------------------------------------------------------------
// Module:  GraphicObjeczAttributeList
//---------------------------------------------------------------------------
// Purpose: lists of attributes
//---------------------------------------------------------------------------


#include "GraphicObjectAttributeList.h"

//===========================================================================
//
//===========================================================================

GraphicObjectAttributeList::GraphicObjectAttributeList()
{
   m_AttributeList.SetAutodelete( true );

} // GraphicObjectAttributeList()

//===========================================================================
//
//===========================================================================

GraphicObjectAttributeList::~GraphicObjectAttributeList()
{
} // ~GraphicObjectAttributeList()

//===========================================================================
//
//===========================================================================

void GraphicObjectAttributeList::AddAttribute(GraphicObjectAttribute *pc_Attribute)
{
   m_AttributeList.AddTail(pc_Attribute);

} // AddAttribute()

//===========================================================================
//
//===========================================================================

GraphicObjectAttribute *GraphicObjectAttributeList::GetAttribute(int e_AttributeType)
{
   int i_Number;
   int i;

   i_Number = m_AttributeList.GetCount();
   for(i=0;i< i_Number; i++)
   {
      GraphicObjectAttribute *pc_ActualAttribute;

      pc_ActualAttribute = m_AttributeList.GetIndex(i);
      if(e_AttributeType == pc_ActualAttribute->m_e_ObjectAttributeType)
      {
         return pc_ActualAttribute;
      }
   } // for i

   // nothing found
   return NULL;

} // GetAttribute()

//===========================================================================
//
//===========================================================================

GraphicObjectAttribute *GraphicObjectAttributeList::GetAttributeByIndex(int i_Index)
{
   GraphicObjectAttribute *pc_ActualAttribute;

   pc_ActualAttribute = m_AttributeList.GetIndex(i_Index);

   return pc_ActualAttribute;

} // GetAttributeByIndex()

//===========================================================================
//
//===========================================================================

int GraphicObjectAttributeList::GetCount()
{
   return m_AttributeList.GetCount();
} // GetCount()

//===========================================================================
//
//===========================================================================

