#ifndef _GRAPHIC_OBJECT_IMAGE_H
#define _GRAPHIC_OBJECT_IMAGE_H


#include "GraphicObject.h"
#include "PixelBuffer.h"

class GraphicObjectImage : public GraphicObject
{
public:
   GraphicObjectImage(float f_StartX, float f_StartY,
                      PixelBuffer *pc_Image);
   GraphicObjectImage(PericoFileWriter *pc_FileWriter);
   virtual RectRegion GetSize();
   virtual void SetSize(RectRegion c_NewSize);
   virtual void MoveTo( float f_OriginX, float f_OriginY);
   virtual void MoveOffset( float f_OffsetX, float f_OffsetY);
   void    SetPosition(float f_StartX, float f_StartY,
                     float f_EndX,   float f_EndY   );
   PixelBuffer *GetImageData();
   virtual Pixel GetPixelAt(int i_X, int i_Y, bool &b_Found);
   virtual QString GetObjectTypeString();

} ; // GraphicObjectImage


#endif //  _GRAPHIC_OBJECT_IMAGE_H

