//---------------------------------------------------------------------------
// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the GPL license.
// If you expand this file, please contact me, that I can integrate the
// enhancements in the original file.
//---------------------------------------------------------------------------
// Module: GraphicObjectLayerList
//---------------------------------------------------------------------------
// Purpose: list for multiple layers
//---------------------------------------------------------------------------

#include "GraphicObjectLayerList.h"


//===========================================================================
//
//===========================================================================

GraphicObjectLayerList::GraphicObjectLayerList()
{

} // GraphicObjectLayerList()

//===========================================================================
//
//===========================================================================

GraphicObjectLayerList::~GraphicObjectLayerList()
{
   // should delete the entire layer, because auto-remove
   // is on
   m_ObjectLayerList.SetAutodelete(true);
   m_ObjectLayerList.Remove();
} // GraphicObjectLayerList()

//===========================================================================
//
//===========================================================================

void GraphicObjectLayerList::AddLayer(GraphicObjectLayer *pc_Layer)
{
   m_ObjectLayerList.AddTail(pc_Layer);

} // Addlayer()

//===========================================================================
//
//===========================================================================

int GraphicObjectLayerList::GetCount()
{
   return m_ObjectLayerList.GetCount();
} // Addlayer()

//===========================================================================
//
//===========================================================================

GraphicObjectLayer *GraphicObjectLayerList::GetLayer(int i_Index)
{
   return m_ObjectLayerList.GetIndex(i_Index);
} // GetLayer()

//===========================================================================
//
//===========================================================================

