#ifndef _GRAPHIC_OBJECT_LINE_H
#define _GRAPHIC_OBJECT_LINE_H


#include "GraphicObject.h"
#include "Geometry.h"

class GraphicObjectLine : public GraphicObject
{
public:
   GraphicObjectLine(float f_StartX, float f_StartY,
                     float f_EndX,   float f_EndY   );
   GraphicObjectLine(GeoCoordinate c_Start,GeoCoordinate c_End);
   GraphicObjectLine(PericoFileWriter *pc_fileWriter);
                     
   virtual RectRegion GetSize();
   virtual void SetSize(RectRegion c_NewSize);
   virtual void MoveTo( float f_OriginX, float f_OriginY);
   virtual void MoveOffset( float f_OffsetX, float f_OffsetY);
   void    SetPosition(float f_StartX, float f_StartY,
                     float f_EndX,   float f_EndY   );
   bool AllowsLineEndMovement();
   void SetAllowsLineEndMovement(bool b_Allow);

   GeoCoordinate GetStartPoint();
   GeoCoordinate GetEndPoint();
   void SetStartPoint(float f_StartX, float f_StartY);
   void SetEndPoint  (float f_EndX,   float f_EndY);
   void SetStartPoint(GeoCoordinate c_Start);
   void SetEndPoint  (GeoCoordinate c_End);
   GeoLine GetLine();
   virtual QString GetObjectTypeString();

private:
   void Initialize(float f_StartX, float f_StartY,
                     float f_EndX,   float f_EndY);   
   
} ; // GraphicObjectLine


#endif //  _GRAPHIC_OBJECT_LINE_H

