
#include <stdio.h>

#include "GraphicObject.h"
#include "GraphicObjectList.h"



//===========================================================================
//
//===========================================================================

GraphicObjectList::GraphicObjectList(bool b_SetAutoDelete)
{
   m_ObjectList.SetAutodelete( b_SetAutoDelete );
   m_b_IsAutoDelete = b_SetAutoDelete;

} // GraphicObjectList()

//===========================================================================
//
//===========================================================================

void GraphicObjectList::AddObject(GraphicObject *pc_Object)
{
   m_ObjectList.AddTail(pc_Object);

} // AddObject()

//===========================================================================
//
//===========================================================================

int  GraphicObjectList::GetCount()
{
   return m_ObjectList.GetCount();

} // GetGount()

//===========================================================================
//
//===========================================================================

GraphicObject *GraphicObjectList::GetObject(int i_Index)
{
   return m_ObjectList.GetIndex(i_Index);

} // GetObject()

//===========================================================================
//
//===========================================================================

void GraphicObjectList::DeleteObject(GraphicObject *pc_ObjectToRemove)
{
   m_ObjectList.Remove(pc_ObjectToRemove);
} // DeleteObject()

//===========================================================================
//
//===========================================================================

void GraphicObjectList::DeleteAllObjects()
{
   m_ObjectList.Remove();
} // DeleteAllObjects()

//===========================================================================
//
//===========================================================================

void GraphicObjectList::RemoveObject(GraphicObject *pc_ObjectToRemove)
{
   if(m_b_IsAutoDelete)
   {
      // disable it
      m_ObjectList.SetAutodelete(false);
      m_ObjectList.Remove(pc_ObjectToRemove);
      // enable it
      m_ObjectList.SetAutodelete(true);
   }
   else
   {
      m_ObjectList.Remove(pc_ObjectToRemove);
   }
   
} // RemoveObject()

//===========================================================================
//
//===========================================================================

void GraphicObjectList::RemoveAllObjects()
{
   if(m_b_IsAutoDelete)
   {
      // disable it
      m_ObjectList.SetAutodelete(false);
      m_ObjectList.Remove();
      // enable it
      m_ObjectList.SetAutodelete(true);
   }
   else
   {
      m_ObjectList.Remove();
   }
} // RemoveAllObjects()

//===========================================================================
//
//===========================================================================

void GraphicObjectList::SetObjectOrderBottom(GraphicObject *pc_Object)
{
   bool b_AutoDeleteSave;

   // get autodelete state
   b_AutoDeleteSave = m_ObjectList.GetAutodelete();
   // disable it
   m_ObjectList.SetAutodelete(false);
   
   // remove the object first
   m_ObjectList.Remove(pc_Object);

   // add it as last object
   m_ObjectList.AddTail(pc_Object);
         
   // set original state
   m_ObjectList.SetAutodelete(b_AutoDeleteSave);

} // SetObjectOrderBottom()

//===========================================================================
//
//===========================================================================

void GraphicObjectList::SetObjectOrderTop(GraphicObject *pc_Object)
{
   bool b_AutoDeleteSave;

   // get autodelete state
   b_AutoDeleteSave = m_ObjectList.GetAutodelete();
   // disable it
   m_ObjectList.SetAutodelete(false);

   // remove the object first
   m_ObjectList.Remove(pc_Object);

   // add it as first object
   m_ObjectList.AddHead(pc_Object);

   // set original state
   m_ObjectList.SetAutodelete(b_AutoDeleteSave);

} // SetObjectOrderTop()

//===========================================================================
//
//===========================================================================


