#ifndef _GRAPHIC_OBJECTLIST_H
#define _GRAPHIC_OBJECTLIST_H

#include <qstring.h>

#include "PTypes.h"
#include "Geometry.h"

#include "GlobalStorage.h"
#include "RectRegion.h"

#include "GraphicObjectAttribute.h"
#include "GraphicObject.h"
#include "PList.h"


//#########################################################################


class GraphicObjectList
{
public :
   GraphicObjectList(bool SetAutoDelete=true);
   void AddObject(GraphicObject *pc_Object);
   int  GetCount();
   GraphicObject *GetObject(int i_Index);

   void DeleteObject(GraphicObject *pc_ObjectToRemove);
   void DeleteAllObjects();

   void RemoveObject(GraphicObject *pc_ObjectToRemove);
   void RemoveAllObjects();


   void SetObjectOrderBottom(GraphicObject *pc_Object);
   void SetObjectOrderTop(GraphicObject *pc_Object);

private:
   PPtrList<GraphicObject> m_ObjectList;
   bool m_b_IsAutoDelete;

};

#endif //  _GRAPHIC_OBJECTLIST_H

