#ifndef _GRAPHIC_OBJECT_MULTIPOINT_H
#define _GRAPHIC_OBJECT_MULTIPOINT_H


#include "GraphicObject.h"
#include "PixelBuffer.h"

class GraphicObjectMultipoint : public GraphicObject
{
public:
   GraphicObjectMultipoint();
   GraphicObjectMultipoint(PericoFileWriter *pc_FileWriter);
   virtual ~GraphicObjectMultipoint();

   virtual RectRegion GetSize();
   virtual void SetSize(RectRegion c_NewSize);
   virtual void MoveTo( float f_OriginX, float f_OriginY);
   virtual void MoveOffset( float f_OffsetX, float f_OffsetY);
   virtual QString GetObjectTypeString();

   void AddCoordinate(GeoCoordinate c_Coordinate);
   int GetCoordinateCount();
   GeoCoordinate GetCoordinate(int i_Index);
   void RemoveAllCoordinates();
   void SetCoordinate(int i_Index,GeoCoordinate c_Coordinate);
   void InsertCoordinate(int i_Index,GeoCoordinate c_Coordinate);
   void RemoveCoordinate(int i_Index);

   void SetClosedFigure(bool b_Closed);
   bool IsClosedFigure();

   GeoCoordinateList *GetCoordinateList();   
} ; // GraphicObjectMultipoint


#endif //  _GRAPHIC_OBJECT_MULTIPOINT_H

