#ifndef _IMAGEINFOBOX_H
#define _IMAGEINFOBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qtextedit.h>


#include "StandardDialog.h"
#include "QtUtilities.h"
#include "ImageInfo.h"


class ImageInfoBox :   public StandardDialog
{
Q_OBJECT

public:
   ImageInfoBox(QWidget *parent=0,
                GlobalStorage *pc_Global=0);
   ~ImageInfoBox();

   void SetSize(int i_Width,int i_Height);
   void SetImageInfo(ImageInfo *pc_Info);
   void GetImageInfo(ImageInfo *pc_Info);


public slots:
   void ApplyPressed();

signals:
   void InformationChanged();

private:

   
   QLineEdit              * m_ImageNameEdit;
   QtUtilReadOnlyLineEdit * m_SizeEdit;
   QLineEdit              * m_AuthorEdit;
   QLineEdit              * m_CommentEdit;
   QPushButton            * m_ApplyButton;
   QTextEdit              * m_ExifHeader;


}; // class ImageInfoBox


#endif // _IMAGEINFOBOX_H
