
#include "MathHermite.h"

//============================================================================
//
//============================================================================

MathHermite::MathHermite()
{
   Set( 0,0,0,0);

} // MathHermite() - constructor

//============================================================================
//
//============================================================================

MathHermite::MathHermite(double d_XAt0,double d_IncAt0,
               double d_XAt1,double d_IncAt1)
{
   Set( d_XAt0,d_IncAt0, d_XAt1,d_IncAt1);

} // MathHermite() - constructor
               
//============================================================================
//
//============================================================================

MathHermite::~MathHermite()
{

}

//============================================================================
//
//============================================================================

void MathHermite::Set(double d_XAt0,double d_IncAt0,
               double d_XAt1,double d_IncAt1)
{

   // calculate the coeffizients
   d_U = d_XAt0;
   d_T = d_IncAt0;

   d_S = -3 * d_XAt0
         +3 * d_XAt1
         -2 * d_IncAt0
         -    d_IncAt1;

   d_R =  2 * d_XAt0
         -2 * d_XAt1
         +    d_IncAt0
         +    d_IncAt1;

} // MathHermite() - constructor

//============================================================================
//
//============================================================================

double MathHermite::Calc(double d_X)
{
   double d_Return;

   d_Return =   d_R * d_X * d_X *d_X
              + d_S * d_X * d_X
              + d_T * d_X 
              + d_U ;
   
   return d_Return;
} // Calc()

//============================================================================
//
//============================================================================




