#ifndef _PERICOCONTROLFILE_H
#define _PERICOCONTROLFILE_H

#include <qstringlist.h>

class PericoControlFile
{
public:
   PericoControlFile();
   ~PericoControlFile();


   int LoadFile(QString qs_Filename);
   int SaveFile(QString qs_Filename);

   int AddValue(QString qs_Name,QString qs_Value);
   int AddValue(QString qs_Value);

   void LevelIncrement();
   void LevelDecrement();

   int GetValue(QString &qsName,
                QString &qs_Value,
                bool &b_IsStartStructure,
                bool &b_IsEndStructure);

   void SkipStructure();
private:
   QStringList m_List;


   // for nested structures
   int m_i_CurrentLevel;

   int m_i_CurrentReadLine;
   

};



#endif // _PERICOCONTROLFILE_H
