#ifndef _PICTUREUPDATECONNECTION_H
#define _PICTUREUPDATECONNECTION_H

#include "Callback.h"
#include "PixelBuffer.h"


class PictureUpdateConnectionMessage
{
public:
   enum
   {
      ChildTermination=1,
      ParentTermination,
      ImageUpdated
   };
   int           m_i_MessageType;
   PixelBuffer * m_pc_Buffer;
} ;


class PictureUpdateConnection
{
public:
   PictureUpdateConnection(Callback C_ParentCallback);
   PictureUpdateConnection();
   ~PictureUpdateConnection();

   void CleanChild();

   void SetParentCallback(Callback C_ParentCallback);
   void SetChildCallback(Callback C_ChildCallback);
   void RemoveChildCallback();
   
   void TellParentTerminate();
   void TellChildTerminate();

   void TellChildHasUpdatedImage(PixelBuffer *pc_Buffer);
   
private:
   Callback m_c_ParentCallback;
   Callback m_c_ChildCallback;

   PictureUpdateConnectionMessage m_Message;
} ;



#endif  // _PICTUREUPDATECONNECTION_H

