#ifndef _QUCOLORORPATTERN_H
#define _QUCOLORORPATTERN_H

#include <qlabel.h>
#include <qslider.h>
#include <qvbox.h>
#include <qcheckbox.h>

#include "BrushMode.h"
#include "GlobalStorage.h"
#include "QUColorDragWidget.h"
#include "QUImageDragLabel.h"

class ColorSelectBox;

class QUColorOrPattern: public QWidget
{
Q_OBJECT

public:
   QUColorOrPattern(QWidget *parent,
                    GlobalStorage *pc_GlobalStorage,
                    ColorSelectBox *pc_SelectBox=NULL);

   ~QUColorOrPattern();

   void SetColor(Pixel p);
   void SetPattern(PixelBuffer *pc_Pattern);
   Pixel GetColor();
   PixelBuffer * GetPattern();

   BrushMode GetActiveMode();
   void SetColorActive(bool b_Active);

   int WriteFile(PericoFileWriter *pc_FileWriter,QString qs_Name);
   int LoadFile(PericoFileWriter *pc_FileWriter);
   
public slots:
   void PatternToggled(bool b_Mode);
   void ColorToggled(bool b_Mode);
   void MotiveToggled(bool b_Mode);

   void InternalColorChanged(Pixel);
   void InternalImageDropped(PixelBuffer *pc_Image);


signals:
   void ColorChanged(Pixel);
   void ImageDropped(PixelBuffer *pc_Image);
   void ModeChange(BrushMode i_Mode);

private:

   GlobalStorage  *m_pc_GlobalStorage;
   ColorSelectBox *m_pc_SelectBox ;


   QCheckBox *m_ColorSelected;
   QCheckBox *m_PatternSelected;
   QCheckBox *m_MotiveSelected;

   QUColorDragWidget *m_ColorWidget;
   QUImageDragLabel  *m_PatternWidget;

   bool m_b_InUpdate;
   BrushMode  m_i_ActiveMode;

   Pixel        m_p_CurrentColor;
   PixelBuffer *m_pc_CurrentPattern;

}; // class UColorOrPattern




#endif // _QUCOLORORPATTERN_H

