#ifndef _QUFILEICON_H
#define _QUFILEICON_H

#include <time.h>
#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qtabwidget.h>
#include <qtextedit.h>


#include "GlobalStorage.h"
#include "MessageServer.h"
#include "StandardDialog.h"
#include "IconBox.h"


class QUFileIcon
{
public:

   QUFileIcon();
   ~QUFileIcon();
   void LoadIcon();
   QString GetFullname();

   QString      m_qs_Name;
   QString      m_qs_Path;
   PixelBuffer *m_pc_Icon;
   time_t       m_tt_SavedDate;
} ;


class QUFileIconWidget :  public QWidget
{
Q_OBJECT

public:
   QUFileIconWidget(QWidget *parent,unsigned int ui_Mode=0);
   ~QUFileIconWidget();

   int GetNumberOfFiles();
   void SetPath(QString qs_Path);
   void SetWildcard(QString qs_Wildcard);

   void ActicateSelection();

   enum
   {
      ModeDeleteAll =1,
   };

   signals:
   void	IconSelected(QString qs_Filename);

public slots:
   void  IconSelected(int i_IconNumber);
   void  IconClicked(int i_IconNumber);
   void  LoadIcon();
   void  DeleteIcon();
   void  DeleteAllIcons();

private:
   void ReadFileList();
   void DeleteAutosavedList();
   void LoadIcons();
   void TransferFilesIntoBox();
   void LoadFile(int i_Index);
   void SetFileNumberText();

   void SetSensitivity();

   QString m_qs_Wildcard;
   QString m_qs_Directory;

   QPtrList<QUFileIcon> m_l_IconFiles;

   ScrollIconBox *m_pc_IconBox;
   QLabel        *m_StatusLabel;
   QTextEdit     *m_InfoEdit;

   QPushButton   *m_pc_LoadButton;
   QPushButton   *m_pc_DeleteButton;
   QPushButton   *m_pc_DeleteAllButton;

   unsigned int   m_ui_Mode;
   
}; // QUFileIconWidget


#endif // _QUFILEICON_H
