#ifndef _QUICONBUTTON_H
#define _QUICONBUTTON_H

#include <qwidget.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qtooltip.h>

#include "PTypes.h"
#include "GlobalStorage.h"
#include "Tracer.h"
#include "PixelBuffer.h"
#include "PictureUpdateConnection.h"
#include "DragAndDrop.h"

class QUIconButton : public QLabel , public Tracer
{
Q_OBJECT
public:


   QUIconButton(QWidget *p_Parent,
                QString qs_IconName,
                QString qs_Defaulttext,
                unsigned int ui_Mode=0,
                GlobalStorage *pc_GlobalStorage=NULL
               );
   ~QUIconButton();

   enum
   {
      ModeImageReceiver=1,
      ModeContextMenu  =2
   };

   void AddContextString(QString qs_String);
   void SetIcon(PixelBuffer *pc_Buffer);
   

signals:
   void clicked();
   void ImageDropped(PixelBuffer *pc_Image);
   void ContextMenuSelected(int i_Value);

public:
   bool GetSelected();
   void SetSelected(bool b);
   
protected:
   void  mousePressEvent(QMouseEvent *theEvent);
   void dragEnterEvent(QDragEnterEvent* event);
   void dropEvent(QDropEvent* event);

private:
private : // variables


   int m_i_Width;
   int m_i_Height;

   GlobalStorage *m_pc_GlobalStorage;
   bool m_b_Selected;
   QColor m_qc_OriginalColor;

   unsigned int m_ui_Mode;
   QStringList m_qsl_ContextMenuStrings;

   DragAndDrop m_DragAndDrop;

} ;// QQUIconButton


#endif // _QUICONBUTTON_H
