#ifndef _LABELSLIDER_H
#define _LABELSLIDER_H

#include <qlabel.h>
#include <qslider.h>
#include <qvbox.h>
#include <qlineedit.h>


class QULabelSlider: public QWidget
{
Q_OBJECT

public:
   QULabelSlider(QWidget *parent,
                 int i_LabelStyle=0,
                 int i_From=1,
                 int i_To=10,
                 int i_Value=1,
                 QString qs_Description="",
                 int i_DescriptionChars=0
                 );
   ~QULabelSlider();

   enum
   {
      LabelStyleAutomatic=1,
      LabelStyleEdit=2
   };
   
   void SetValue(int i_Value,QString qs_Label="");
   void SetLabel(QString qs_Label);

   int GetValue();
   void SetLabelStringSize(int i_Letters);

public slots:
   void DoSliderValueChanged(int);
   void EditFieldChanged(const QString & qs_NewText);

signals:
   void	valueChanged(int);


private:
   
   QLabel      *m_SliderDescription;

   QSlider     *m_Slider;
   QLineEdit   *m_SliderEdit;
   QLabel      *m_SliderLabel;
   
   int     m_i_DescriptionChars;
   int     m_i_CurrentValue;
   QString m_qs_CurrentLabel;
   bool    m_b_AutomaticLabel;
   bool    m_b_EditLabel;
   int     m_i_LabelStyle;

   int     m_i_FromValue;
   int     m_i_ToValue;

   bool    m_b_DisableUpdate;

}; // class QULabelSlider




#endif // _LABELSLIDER_H

