#ifndef _QUPIXELBUTTON_H
#define _QUPIXELBUTTON_H

#include <qpushbutton.h>
#include <qstringlist.h>

#include "DragAndDrop.h"

class PixelBuffer;


class QUPixelButton : public QPushButton
{
Q_OBJECT

public:
   QUPixelButton(QWidget *parent,
                 QString qs_IconName,
                 QString qs_DefaultText,
                 unsigned int ui_Mode=0);
   enum
   {
      ModeImageReceiver=1,
      ModeContextMenu  =2
   };
   void AddContextString(QString qs_String);
   void SetIcon(PixelBuffer *pc_Buffer);

signals:
   void ImageDropped(PixelBuffer *pc_Image);
   void ContextMenuSelected(int i_Value);
   
private:
   void dragEnterEvent(QDragEnterEvent* event);
   void dropEvent(QDropEvent* event);

   virtual void mousePressEvent ( QMouseEvent * e );
                 
   unsigned int m_ui_Mode;
   QStringList m_qsl_ContextMenuStrings;

   DragAndDrop m_DragAndDrop;
   
}; // class QUPixelButton



#endif // _QUPIXELBUTTON_H

