#ifndef _QUSELECTICONBUTTON_H
#define _QUSELECTICONBUTTON_H

#include <qpushbutton.h>
#include <qstringlist.h>

class PixelBuffer;

#include "QUIconButton.h"



class QUSelectIconButton : public QWidget
{
Q_OBJECT

public:
   QUSelectIconButton(QWidget *parent,
                 QString qs_IconName,
                 QString qs_DefaultText,
                 unsigned int ui_Mode=0);

   void SetSelected(bool b_Selected);
   bool GetSelected();
   void AddContextString(QString qs_String);
   void SetIcon(PixelBuffer *pc_Buffer);

public slots:
   void ButtonClicked();
   void ButtonImageDropped(PixelBuffer *pc_Image);
   void ButtonContextMenuSelected(int i_Value);
   
signals:
   void clicked();
   void ImageDropped(PixelBuffer *pc_Image);
   void ContextMenuSelected(int i_Value);
   
private:
   QUIconButton * m_pc_Button;

   bool m_b_Selected;
   QColor m_qc_OriginalColor;
   unsigned int m_ui_Mode;
   
};


#endif // _QUSELECTICONBUTTON_H

