#ifndef _QUTOOLBUTTON_H
#define _QUTOOLBUTTON_H

#include <qtoolbutton.h>
#include <qstringlist.h>

#include "DragAndDrop.h"

class PixelBuffer;


class QUToolButton : public QToolButton
{
Q_OBJECT

public:
   QUToolButton(QWidget *parent,
                 QString qs_IconName,
                 QString qs_DefaultText,
                 unsigned int ui_Mode=0);
   enum
   {
      ModeImageReceiver=1,
      ModeContextMenu  =2
   };
   void AddContextString(QString qs_String);
   void SetIcon(PixelBuffer *pc_Buffer);

signals:
   void ImageDropped(PixelBuffer *pc_Image);
   void ContextMenuSelected(int i_Value);
   
private:
   void dragEnterEvent(QDragEnterEvent* event);
   void dropEvent(QDropEvent* event);

   virtual void mousePressEvent ( QMouseEvent * e );
                 
   unsigned int m_ui_Mode;
   QStringList m_qsl_ContextMenuStrings;

   DragAndDrop m_DragAndDrop;
   
}; // class QUToolButton



#endif // _QUTOOLBUTTON_H

