#ifndef _QUTREEPATH_H
#define _QUTREEPATH_H

#include <qlabel.h>
#include <qslider.h>
#include <qvbox.h>
#include <qlineedit.h>
#include <qlistview.h>

#include "PList.h"

//######################################################

class QUTreePathEntry
{
public:
   QUTreePathEntry();
   
   bool m_b_IsDirectory;

   QString m_qs_Elementname;
   QString m_qs_Fullname;

   PPtrList <QUTreePathEntry> m_l_ChildList;

   void AddPath(QString qs_Name,QString qs_Fullname);
   void AddViewRecursive(QListViewItem *lv_Parent);

}; // QUTreePathEntry

//######################################################


class QUTreePath: public QListView
{
Q_OBJECT

public:
   QUTreePath(QWidget *parent
                 );
   ~QUTreePath();

   void AddPath(QString qs_Fullname);

   void ViewList(QString qs_RootName);

   QString GetSelected();

public slots:

   void SelectionChanged();

signals:
   void SelectionHasChanged(QString qs_Name);


private:

   QUTreePathEntry m_Root;
   QString m_qs_Selected;
   
}; // class QUTreePath:


//######################################################


#endif // _QUTREEPATH_H

