#ifndef _QTUTILITIES_H
#define _QTUTILITIES_H

#include <qwidget.h>
#include <qlineedit.h>


class QtUtilSpacer
                  : public QWidget
{
public:
   QtUtilSpacer(bool ExpandHorizontal,
                bool ExpandVertical,
                QWidget *Parent);
};

class QtUtilLine
                  : public QWidget
{
public:
   QtUtilLine(bool Horizontal,
                bool Vertical,
                QWidget *Parent);
};

class QtUtilReadOnlyLineEdit
        : public QLineEdit
{
public:
   QtUtilReadOnlyLineEdit(QWidget *Parent);
};



class QtUtility
{
public:
   QtUtility();

   int GetMaximalFontWidth();
   int GetMaximalFontHeight();
   
   static void StartWaitingCursor();
   static void EndWaitingCursor();
   
   static QString GetDragSourceName(QByteArray *qba_Data,
                                    QString *pqs_Value = NULL);
   static QString GetDragSourceText(QByteArray *qba_Data);

   static void SetWidgetReadOnlyColor(QWidget *w_Widget);
private:
   int m_i_MaxFontWidth;
   int m_i_MaxFontHeight;

};


#endif //  _QTUTILITIES_H


