#ifndef _SETTINGSBOX_H
#define _SETTINGSBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qtabwidget.h>

#include "GlobalStorage.h"
#include "MessageServer.h"
#include "StandardDialog.h"
#include "QULabelSlider.h"
#include "QUFileSelectEdit.h"

class SettingsBox :  public StandardDialog
{
Q_OBJECT

public:
   SettingsBox(QWidget *parent);

public slots:
   void ApplyPressed();
   void ResetPressed();

private:

   void LoadDefaults();

   QTabWidget    *m_TabWidget;

   QWidget       *m_NLSSettings;
   QUFileSelectEdit *m_w_NLSFile;

   QWidget       *m_FileSettings;
   QULabelSlider *m_w_JpegQualitySlider;
   QUFileSelectEdit  *m_w_DefaultDirectory;


   QUFileSelectEdit *m_w_TempDirectory;
   QWidget       *m_w_TempSettings;

   QWidget       *m_w_AutosaveSettings;
   QCheckBox     *m_w_AutosaveEnabledCheck;
   QULabelSlider *m_w_AutosaveNumberOfImagesSlider;
   QULabelSlider *m_w_AutosaveIntervalSlider;
   QCheckBox     *m_w_AutosaveTellAtStartup;
   
   QPushButton *m_w_ApplyButton;
   QPushButton *m_w_ResetButton;

};


#endif // _SETTINGSBOX_H
