//---------------------------------------------------------------------------
// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the GPL license.
// If you expand this file, please contact me, that I can integrate the
// enhancements in the original file.
//---------------------------------------------------------------------------
// Module: StatusBar
//---------------------------------------------------------------------------
// Purpose: Shows at the bottom the current status
//---------------------------------------------------------------------------

#include <qsizepolicy.h>
#include <qhgroupbox.h>
#include <qlayout.h>

#include "StatusBar.h"
#include "ApplicationStorage.h"


//===========================================================================
//
//===========================================================================

StatusBar::StatusBar(QStatusBar *p_Parent)
{
   QHBoxLayout  *SliderLayout;
   int           i_WidgetHeight;

   m_Container = new QWidget(p_Parent);
   // add container and stretch to maximum
   p_Parent->addWidget(m_Container,100);

   SliderLayout  = new  QHBoxLayout( m_Container,0);

   m_CoordinateEdit = new QtUtilReadOnlyLineEdit(m_Container);
   m_CoordinateEdit->setMinimumWidth(
                         g_Application->m_pc_QtUtility->GetMaximalFontWidth() *8 );
   m_CoordinateEdit->setMaximumWidth(
                         g_Application->m_pc_QtUtility->GetMaximalFontWidth() *8 );

   m_OperationEdit  = new QtUtilReadOnlyLineEdit(m_Container);
   m_OperationEdit->setMinimumWidth(
                         g_Application->m_pc_QtUtility->GetMaximalFontWidth() *4 );

   SliderLayout->addWidget(m_CoordinateEdit);
   SliderLayout->addWidget(m_OperationEdit);

   i_WidgetHeight =m_OperationEdit->height();

} // StatusBar() -constructor

//===========================================================================
//
//===========================================================================

void StatusBar::SetCoordinate(int i_X, int i_Y)
{
   QString qs_Text;

   m_i_X = i_X;
   m_i_Y = i_Y;

   qs_Text.sprintf("X:%4d  Y:%4d",m_i_X, m_i_Y);
   m_CoordinateEdit->setText(qs_Text);

} // SetCoordinate()

//===========================================================================
//
//===========================================================================

void StatusBar::SetOperationMode(QString qs_Operation)
{
   m_qs_Operation = qs_Operation;
   
   m_OperationEdit->setText(m_qs_Operation);

} // SetOperationMode()

//===========================================================================
//
//===========================================================================


