#ifndef _UNDO_H
#define _UNDO_H

#include "PixelBuffer.h"
#include <qwidget.h>
#include "StandardDialog.h"

class ScrollIconBox;
class GlobalStorage;


class Undo : public StandardDialog
{
   Q_OBJECT

public:
   Undo(QWidget *pc_Parent,
      GlobalStorage *pc_Global=0);
   ~Undo();
  public slots:
    void BoxIconSelected(int i_Value);

   signals:
   void	IconSelected(int);

public:
   
   void SaveBufferToUndo(PixelBuffer *pc_Original);

   void DoUndo(PixelBuffer * &pc_BufferToGetRestored,bool &b_SizeChanged);
   void DoRedo(PixelBuffer * &pc_BufferToGetRestored,bool &b_SizeChanged);
   void DoUndo(PixelBuffer * &pc_BufferToGetRestored,
               bool &b_SizeChanged,
               int i_Version);
   
   void Reset();

   bool IsRedoPossible();
   bool IsUndoPossible();

   
   PixelBuffer * GetActualPicture();
   void ShowSelectionBox();

private:
   // 2nd attempt more than one undo buffer
   int         m_i_NumberOfUndoBuffers;
   PixelBuffer **m_pc_UndoBufferList;
   int         m_i_ActualImageIndex;
   int         m_i_ImagesFilled;

   void        RestoreFrom(PixelBuffer *pc_Destination,
                           PixelBuffer *pc_Source,
                           bool &b_SizeChanged);

   void     TransferIcons();
   void     SetActiveIcon();


   void print();

   ScrollIconBox *m_pc_IconBox;

   QWidget *m_pc_Parent ;
};



#endif // _UNDO_H
