#ifndef _XenoHandler_H
#define _XenoHandler_H


#include "XenoLib.h"
#include "PixelBuffer.h"


#include <qstring.h>

class XenoHandler
{
public:

   XenoHandler();
   ~XenoHandler();

   QStringList * GetKernalNames();

   void ProcessImage(PixelBuffer *pc_Buffer,
               QString qs_KernelName);

private:
   void LoadKernels();
   void ExtractKernels(QString qs_Path);

   XenoKERNEL_MANAGER m_c_Kernelmanager;

   void ScanDirectory(QString rootpath);
   void ConvertToDsp(PixelBuffer *pc_Buffer);
   void ConvertFromDsp(PixelBuffer *pc_Buffer);
   void StartFilter(QString qs_KernelName);
    

   QStringList m_qsl_KernelNameList;

   XenoDSP2D *m_pc_RedInBuffer;
   XenoDSP2D *m_pc_GreenInBuffer;
   XenoDSP2D *m_pc_BlueInBuffer;
   
   XenoDSP2D *m_pc_RedOutBuffer;
   XenoDSP2D *m_pc_GreenOutBuffer;
   XenoDSP2D *m_pc_BlueOutBuffer;

   XenoKERNEL2D *m_pc_KernelRed;
   XenoKERNEL2D *m_pc_KernelGreen;
   XenoKERNEL2D *m_pc_KernelBlue;
   
   int m_i_Width;
   int m_i_Height;

   QString m_qs_BasePath;
   int     m_i_BasePathLength;

};

#endif // _XenoHandler_H
