// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the GPL license:
// Everyboy may use it on his own risk. This header must stay in the file!
// If you expand this file, please contact me, that I can integrate the
// enhancemants in the original file.
//
// main-modules for icons

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

#include "PTypes.h"

#include "IconLibrary.h"
#include "PixelBuffer.h"

//===========================================================================
//
//===========================================================================

static char ca_KernelFile[] = "kernels.tgz";

void CreateKernelFile()
{
   FILE *fp_Infile;
   FILE *fp_Outfile;
   int   i_Position;
   unsigned int  ui_Length;
   struct stat s_StatBuffer;

   stat(ca_KernelFile,&s_StatBuffer);
   ui_Length = s_StatBuffer.st_size;

   fp_Infile = fopen (ca_KernelFile,"rb");
   if(fp_Infile == NULL)
   {
      return;
   }
   
   
   fp_Outfile = fopen("KernelData.c","w");
   if(fp_Outfile == NULL)
   {
      fclose(fp_Infile);
      return;
   }


   fprintf(fp_Outfile,"// this is an automatic generated file\n");
   fprintf(fp_Outfile,"// Do not edit by hand\n");
   fprintf(fp_Outfile,"\n");
   fprintf(fp_Outfile,"unsigned int g_ui_KernelMemoryDataLength = %ld ; \n",ui_Length);
   fprintf(fp_Outfile,"unsigned char g_uc_KernelMemoryData[] = { \n");

   i_Position =0;
   while(! feof(fp_Infile))
   {
      unsigned int ui_Value;

      ui_Value = fgetc(fp_Infile);
      fprintf(fp_Outfile,"0x%02x,",(unsigned char) ui_Value);

      i_Position += 1;
      if(i_Position>31)
      {
         fprintf(fp_Outfile,"\n");
         i_Position =0;
      }
   
   } // while not eof
   
   fprintf(fp_Outfile,"0}; \n");
   fclose(fp_Outfile);
   fclose(fp_Infile);

   
} // CreateKernelFile()

//===========================================================================
//
//===========================================================================


int main(int argc, char *argv[])
{
   IconLibrary *ic;
   QString qs_PureName;
   int          i;

   if(argc<=1)
   {
      exit(0);
   }
   ic = new IconLibrary(NULL);

   for(i=1; i<argc;i++)
   {
      int i_Point;
      fprintf(stderr,"%s\n",argv[i]);
      qs_PureName =argv[i];
      i_Point = qs_PureName.find('.');
      if(i_Point <0)
      {
         continue;
      }
      // remove the point
      qs_PureName = qs_PureName.left(i_Point);
      ic->AddIconFromFile(qs_PureName,argv[i]);

   } // for all arguments

   ic->SaveToCFile("IconData.c");

   CreateKernelFile();

} // main()

